=== debian/changelog ===
grandorgue (3.12.1-1) unstable; urgency=medium

  * New upstream version 3.12.1
  * d/copyright: reflect upstream changes
  * Add libyaml-cpp-dev to Build-Depends, for YAML export of combinations

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 11 Jun 2023 18:21:58 +0200
