## grandorgue 3.12.2

=== src/grandorgue/CMakeLists.txt ===
--- 
+++ 
@@ -46,8 +46,9 @@
 
 set(grandorgue_src
 combinations/control/GOCombinationButtonSet.cpp
+combinations/control/GOCombinationControllerProxy.cpp
+combinations/control/GODivisionalButtonControl.cpp
 combinations/control/GOGeneralButtonControl.cpp
-combinations/control/GODivisionalButtonControl.cpp
 combinations/model/GOCombination.cpp
 combinations/model/GOCombinationDefinition.cpp
 combinations/model/GODivisionalCombination.cpp
@@ -67,6 +68,7 @@
 control/GOPistonControl.cpp
 dialogs/common/GODialogCloser.cpp
 dialogs/common/GODialogTab.cpp
+dialogs/common/GOSimpleDialog.cpp
 dialogs/common/GOTabbedDialog.cpp
 dialogs/midi-event/GOMidiEventDialog.cpp
 dialogs/midi-event/GOMidiEventKeyTab.cpp
@@ -94,6 +96,7 @@
 gui/primitives/GOBitmap.cpp
 gui/primitives/GODC.cpp
 gui/primitives/GOFont.cpp
+gui/primitives/go_gui_utils.cpp
 gui/GOGUIBankedGeneralsPanel.cpp
 gui/GOGUIButton.cpp
 gui/GOGUICrescendoPanel.cpp
@@ -209,6 +212,7 @@
 GOFrame.cpp
 GODocument.cpp
 GOPanelView.cpp
+GOVirtualCouplerController.cpp
 )
 
 if (USE_INTERNAL_ZITACONVOLVER)
