=== debian/changelog ===
grandorgue (3.12.2-1) unstable; urgency=medium

  * New upstream version 3.12.2

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 23 Jul 2023 14:17:49 +0200
