## grandorgue 3.12.3

=== debian/changelog ===
grandorgue (3.12.3-1) unstable; urgency=medium

  * New upstream version 3.12.3

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 18 Aug 2023 16:20:05 +0200
