=== debian/changelog ===
grandorgue (3.13.0-1) unstable; urgency=medium

  * New upstream version 3.13.0

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 19 Oct 2023 03:21:42 +0200
